Bug 27728 - Exception in Exception filters (C# 6)
Summary: Exception in Exception filters (C# 6)
Status: CONFIRMED
Alias: None
Product: Runtime
Classification: Mono
Component: JIT (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2015-03-06 07:25 UTC by Marek Safar
Modified: 2018-02-28 23:57 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report for Bug 27728 on GitHub or Developer Community if you have new information to add and do not yet see a matching new report.

If the latest results still closely match this report, you can use the original description:

  • Export the original title and description: GitHub Markdown or Developer Community HTML
  • Copy the title and description into the new report. Adjust them to be up-to-date if needed.
  • Add your new information.

In special cases on GitHub you might also want the comments: GitHub Markdown with public comments

Related Links:
Status:
CONFIRMED

Description Marek Safar 2015-03-06 07:25:04 UTC
Compile and Run

using System;
using static System.Console;

	class Program
	{
		static void Main(string[] args)
		{
			try
			{
				throw new Exception("TEST Exception");
			}
			catch (Exception ex) when (MethodThatThrowsAnException())
			{
				WriteLine("Filtered handler 1");
			}
			catch (IndexOutOfRangeException ex)
			{
				WriteLine("Index out of Range from Method Filter");
			}

			catch (Exception ex)
			{
				WriteLine("Forced Exception is caught " + ex);
			}
		}

		static bool MethodThatThrowsAnException()
		{
			throw new IndexOutOfRangeException("Index Out of Range");
		}
	}
Mono:

Unhandled Exception:
System.IndexOutOfRangeException: Index Out of Range
  at Program.Main (System.String[] args) [0x00000] in <filename unknown>:0

.NET

Forced Exception is caught System.Exception: TEST Exception
   at Program.Main(String[] args)
Comment 1 Ludovic Henry 2018-02-28 23:57:29 UTC
I can reproduce with Mono 5.13.0.220 (master/798c5efa52a).